#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname	RapidJSON
#-----------------------------------------------------------------------------
Name		:	rapidjson
Version		:	1.1.0
Release		:	14.8.0.0%{?dist}
Summary		:	Fast JSON parser and generator for C++

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://github.com/Tencent/rapidjson

Source0		:	%{name}-%{version}.tar.gz
patch0		:	%{name}-%{version}-c++20.patch

#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	doxygen
BuildRequires	:	gcc-c++
BuildRequires	:	gtest-devel
BuildRequires	:	make
BuildRequires	:	valgrind

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description
RapidJSON is a fast JSON parser and generator for C++.
It was inspired by RapidXml.							
									
  RapidJSON is small but complete.  It supports
  both SAX and DOM style API.
  The SAX parser is only a half thousand lines of code.		
									
  RapidJSON is fast.  Its performance can be comparable
  to strlen(). It also optionally supports SSE2/SSE4.1
  for acceleration.		
									
  RapidJSON is self-contained.  It does not depend on external		
  libraries such as BOOST.  It even does not depend on STL.		
									
  RapidJSON is memory friendly.  Each JSON value occupies exactly	
  16/20 bytes for most 32/64-bit machines (excluding text string).  By	
  default it uses a fast memory allocator, and the parser allocates	
  memory compactly during parsing.					
									
  RapidJSON is Unicode friendly.  It supports UTF-8, UTF-16, UTF-32	
  (LE & BE), and their detection, validation and transcoding		
  internally.  For example, you can read a UTF-8 file and let RapidJSON	
  transcode the JSON strings into UTF-16 in the DOM.  It also supports	
  surrogates and "\u0000" (null character).				
									
JSON(JavaScript Object Notation) is a light-weight data exchange	
format.  RapidJSON should be in fully compliance with RFC4627/ECMA-404.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)

#=============================================================================
%package		devel
Summary		:	development files for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}			= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries for
developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%license license.txt
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/error/*.h
%{_includedir}/%{name}/internal/*.h
%{_includedir}/%{name}/msinttypes/*.h
%{_libdir}/cmake/%{sname}/%{sname}*.cmake
%{_libdir}/pkgconfig/%{sname}.pc
%{_defaultdocdir}/%{name}-%{version}/readme.md

#=============================================================================
%package		doc
Summary		:	Documentation-files for %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}-devel		= %{version}-%{release}

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description		doc
This package contains the documentation-files for %{name}.

#-----------------------------------------------------------------------------
%files			doc
%{_defaultdocdir}/%{name}-%{version}/examples/*/*.cpp
%{_defaultdocdir}/%{name}-%{version}/examples/CMakeLists.txt
%{_defaultdocdir}/%{name}-%{version}/html/*.css
%{_defaultdocdir}/%{name}-%{version}/html/*.html
%{_defaultdocdir}/%{name}-%{version}/html/*.js
%{_defaultdocdir}/%{name}-%{version}/html/*.png
%{_defaultdocdir}/%{name}-%{version}/html/*.svg
%{_defaultdocdir}/%{name}-%{version}/html/search/search.css
%{_defaultdocdir}/%{name}-%{version}/html/search/*.js
%{_defaultdocdir}/%{name}-%{version}/html/search/*.svg
%{_defaultdocdir}/%{name}-%{version}/html/zh-cn/*

#=============================================================================
%prep
%setup -q
%patch -P 0 -p1

find -name CMakeLists.txt | xargs sed -e 's|-Werror||' -i # Don't use -Werror

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-S .						\
	-B _build					\
	-D CMAKE_BUILD_TYPE=None			\
	-D CMAKE_INSTALL_PREFIX:PATH=%{_prefix}		\
	-D RAPIDJSON_HAS_STDSTRING=ON			\
	-D RAPIDJSON_BUILD_CXX11=ON			\
	-D DOC_INSTALL_DIR=%{_defaultdocdir}/%{name}-%{version}


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	-C _build					\
	%{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	-C _build					\
	install

#-----------------------------------------------------------------------------
%changelog
